commit fdbff5ae722033ddb8028358f25dda358e5d506c
Author: freddy77 <freddy77>
Date:   Wed Jan 21 08:34:01 2009 +0000

    fix unsigned/signed issues

diff --git a/ChangeLog b/ChangeLog
index 751233c..51b679c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Jan 21 09:33:39 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/replacements/vasprintf.c: fix portability problem
+	* src/tds/challenge.c: check correctly error converting to ucs2
+
 Mon Jan 19 15:36:50 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/mem.c: dos2unix
 
@@ -1213,4 +1217,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2711 2009/01/19 14:37:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2712 2009/01/21 08:34:01 freddy77 Exp $
diff --git a/src/replacements/vasprintf.c b/src/replacements/vasprintf.c
index 7d1ded4..9183903 100644
--- a/src/replacements/vasprintf.c
+++ b/src/replacements/vasprintf.c
@@ -30,7 +30,7 @@
 #include "tds_sysdep_private.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: vasprintf.c,v 1.19 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: vasprintf.c,v 1.20 2009/01/21 08:34:01 freddy77 Exp $");
 
 #if defined(HAVE__VSNPRINTF) && !defined(HAVE_VSNPRINTF)
 #undef HAVE_VSNPRINTF
@@ -67,10 +67,10 @@ vasprintf(char **ret, const char *fmt, va_list ap)
 		free(buf);
 		buflen = (++chunks) * CHUNKSIZE;
 		/* 
-		 * len >= 0 are required for vsnprintf implementation that 
-		 * return -1 of buffer insufficient
+		 * len >= 0 is required for vsnprintf implementations that 
+		 * return -1 for insufficient buffer
 		 */
-		if (buflen <= (size_t) len) {
+		if (len >= 0 && buflen <= (size_t) len) {
 			buflen = len + 1;
 		}
 	}
diff --git a/src/tds/challenge.c b/src/tds/challenge.c
index 6a4c0d1..ae0b7a0 100644
--- a/src/tds/challenge.c
+++ b/src/tds/challenge.c
@@ -1,6 +1,6 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  * Copyright (C) 1998-1999  Brian Bruns
- * Copyright (C) 2005-2008  Frediano Ziglio
+ * Copyright (C) 2005-2009  Frediano Ziglio
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: challenge.c,v 1.37 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: challenge.c,v 1.38 2009/01/21 08:34:01 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -123,7 +123,7 @@ convert_to_usc2le_string(TDSSOCKET * tds, const char *s, size_t len, char *out)
 	ol = len * 2;
 	memset(suppress, 0, sizeof(char_conv->suppress));
 	if (tds_iconv(tds, char_conv, to_server, &ib, &il, &ob, &ol) == (size_t) - 1)
-		return -1;
+		return (size_t) -1;
 
 	return ob - out;
 }
@@ -153,7 +153,7 @@ make_ntlm_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_hash[16])
 		passwd_len = 128;
 
 	passwd_usc2le_len = convert_to_usc2le_string(tds, passwd, passwd_len, passwd_usc2le);
-	if (passwd_usc2le_len < 0) {
+	if (passwd_usc2le_len == (size_t) -1) {
 		memset((char *) passwd_usc2le, 0, sizeof(passwd_usc2le));
 		return TDS_FAIL;
 	}
@@ -200,7 +200,7 @@ make_ntlm_v2_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_v2_has
 	convert_to_upper(buf, user_name_len);
 
 	len = convert_to_usc2le_string(tds, buf, user_name_len, buf_usc2le);
-	if (len < 0)
+	if (len == (size_t) -1)
 		return TDS_FAIL;
 	buf_usc2le_len = len;
 
@@ -209,7 +209,7 @@ make_ntlm_v2_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_v2_has
 	/* Target is supposed to be case-sensitive */
 
 	len = convert_to_usc2le_string(tds, domain, domain_len, buf_usc2le + len);
-	if (len < 0)
+	if (len == (size_t) -1)
 		return TDS_FAIL;
 	buf_usc2le_len += len;
 
@@ -265,8 +265,6 @@ tds_answer_challenge(TDSSOCKET * tds,
 {
 #define MAX_PW_SZ 14
 	const char *passwd = tds_dstr_cstr(&connection->password);
-	size_t len;
-	size_t i;
 	static const des_cblock magic = { 0x4B, 0x47, 0x53, 0x21, 0x40, 0x23, 0x24, 0x25 };
 	DES_KEY ks;
 	unsigned char hash[24], ntlm2_challenge[16];
@@ -276,6 +274,7 @@ tds_answer_challenge(TDSSOCKET * tds,
 
 	if (!(*flags & 0x80000)) {
 		/* NTLM */
+		size_t len, i;
 		unsigned char passwd_buf[MAX_PW_SZ];
 
 		/* convert password to upper and pad to 14 chars */
@@ -456,7 +455,7 @@ tds7_send_auth(TDSSOCKET * tds,
 	tds_put_int(tds, 3);	/* sequence 3 */
 
 	/* FIXME *2 work only for single byte encodings */
-	current_pos = 64 + (domain_len + user_name_len + host_name_len) * 2;
+	current_pos = 64u + (domain_len + user_name_len + host_name_len) * 2u;
 
 	/* LM/LMv2 Response */
 	tds_put_smallint(tds, lm_response_len);	/* lan man resp length */
@@ -475,19 +474,19 @@ tds7_send_auth(TDSSOCKET * tds,
 	TDS_PUT_SMALLINT(tds, domain_len * 2);
 	TDS_PUT_SMALLINT(tds, domain_len * 2);
 	TDS_PUT_INT(tds, current_pos);
-	current_pos += domain_len * 2;
+	current_pos += domain_len * 2u;
 
 	/* username */
 	TDS_PUT_SMALLINT(tds, user_name_len * 2);
 	TDS_PUT_SMALLINT(tds, user_name_len * 2);
 	TDS_PUT_INT(tds, current_pos);
-	current_pos += user_name_len * 2;
+	current_pos += user_name_len * 2u;
 
 	/* Workstation Name */
 	TDS_PUT_SMALLINT(tds, host_name_len * 2);
 	TDS_PUT_SMALLINT(tds, host_name_len * 2);
 	TDS_PUT_INT(tds, current_pos);
-	current_pos += host_name_len * 2;
+	current_pos += host_name_len * 2u;
 
 	/* Session Key (optional) */
 	tds_put_smallint(tds, 0);

